/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __TinyFsDef_h
  #define __TinyFsDef_h

/*
  TinyFS filesystem API.
*/

#define FILE_TABLE_RAM_LOCATION         (0x20f00000)
#define FILE_TABLE_FLASH_LOCATION       (0x4000)

// The number of FAT entries is given in ebFlashSetup-file!
//#define FILE_TABLE_MAX_ITEMS            (128)

#define FILE_TABLE_MAGIC                (0x12345678)

// File attributes.
#define DF_BTENTRY_FLAG_USE             (1 << 0)   // use the item //
#define DF_BTENTRY_FLAG_COPY            (1 << 1)   // copy this item to sdram //
#define DF_BTENTRY_FLAG_EXEC            (1 << 2)   // execute this item by default //
#define DF_BTENTRY_FLAG_EXEC_ALTERNATE  (1 << 3)   // execute this item alternatively //
#define DF_BTENTRY_FLAG_COMPRESSED      (1 << 4)

// size = 16+4+4+4+4 = 32 bytes.
struct tDFBlockTableEntry
  {
    char msItem[16];                 // name of image inclusive trailing zero //
    unsigned int mDfBTEntryFlags;    // load / execution flags //
    unsigned int mDfBTEntryDFStart;  // start in dataflash //
    unsigned int mDfBTEntryDFSize;   // size of image //
    unsigned int mDfBTEntryMemStart; // location in sdram where the to be load //
  }  __attribute__((packed));

#endif // __TinyFsDef_h
