/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cCRC16_h
  #define __cCRC16_h

class cCRC16
  {
  public:
    enum FixedSettings { StartValue = 0xffff };
  public:
    /// \brief Calculates the checksum of the given datablock
    static unsigned short crc16(const char* pData, unsigned int iSize);

    /**
      \brief Calculates the checksum of the given datablock (part). The return value is parameter (iLast) on the next call.
      iLast should be initialized with FixedSettings::StartValue on the first call.
    */
    static unsigned short crc16Part(const char* pData, unsigned int iSize, unsigned short iLast = StartValue);
  };

#endif // __cCRC16_h
