/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cDFDevice_h
  #define __cDFDevice_h

#include <list>
#include "cGuardedBuffer.h"
class cTinyFsFile;

class cDFDevice
  {
  public:
    cDFDevice(const std::string& sDevice);
    ~cDFDevice() throw();

   void rawWrite(unsigned int iStart, const char* p, unsigned int iSize);
   void rawRead(unsigned int iStart, char* p, unsigned int iSize);
   unsigned int mediumSize() const;

   unsigned int preferredBlockSize() const;
   unsigned int numSectors() const;
   unsigned int sectorSize() const;

 private:
   void writeSector(unsigned int iSector, const char* p, unsigned int iNumSectors);
   void readSector(unsigned int iSector, char* p, unsigned int iNumSectors);

  private:
    int miFd;
    cGuardedBuffer mpSectorBuffer;
  };


#endif // __cDFDevice_h
