/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cG5AbstractButtonCtrl_h
  #define __cG5AbstractButtonCtrl_h

class cG5AbstractButtonCtrl
  {
  public:
    enum Event
      {
        evNone,              // No user interaction
        evShort,             // User has released the button after pressing a short time.
        evLong,              // User has released the button after pressing a long time.
        evVeryLong,          // User has released the button after pressing a very long time.
        evPendingShort,      // User has not released the button but is pressing it a short time.
        evPendingLong,       // User has not released the button but is pressing it a long time.
        evPendingVeryLong    // User has not released the button but is pressing it a very long time.
     };
  public:
    cG5AbstractButtonCtrl();
    virtual ~cG5AbstractButtonCtrl() throw();

    /// \brief Returns the number of press events. (short)
    virtual unsigned int shortPress() = 0;
    /// \brief Returns the number of press events. (long)
    virtual unsigned int longPress() = 0;
    /// \brief Returns the number of press events. (very long)
    virtual unsigned int veryLongPress() = 0;
    /// \brief Returns true if the button is currently pressed.
    virtual bool isDown() = 0;

    virtual void update() = 0;

    Event event();

  private:
    bool mboFirst;
    unsigned int miSP;
    unsigned int miLP;
    unsigned int miVP;
    bool mboPostedPS;
    bool mboPostedPL;
    bool mboPostedPVL;
  };

#endif // __cG5AbstractButtonCtrl_h
