/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cG5DeviceCtrl_h
  #define __cG5DeviceCtrl_h

#include <string>
#include <memory>

class cG5AbstractStateCtrl;
class cG5Config;

/**
  \brief This class include device control features.
*/
class cG5DeviceCtrl
  {
  public:
    cG5DeviceCtrl(const cG5Config&);
    ~cG5DeviceCtrl() throw();

    const cG5AbstractStateCtrl& state() const;
    cG5AbstractStateCtrl& stateCtrl();

  private:
    class cG5DeviceCtrlImpl;
    std::auto_ptr<cG5DeviceCtrlImpl> mpImpl;
  };

#endif // __cG5DeviceCtrl_h
