/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cG5EthernetCtrl_h
  #define __cG5EthernetCtrl_h

#include <string>
#include <memory>
#include "cG5AbstractNetCtrl.h"

/**
  \brief This class stores the network device settings.
*/
class cG5EthernetCtrl : public cG5AbstractNetCtrl
  {
  public:
    cG5EthernetCtrl();
    virtual ~cG5EthernetCtrl() throw();

    virtual std::string macAddress();
    virtual std::string netIPAddress();
    virtual std::string netIPDefaultGW();
    virtual bool netIPUseDHCP();

    virtual void netIPSetAddress(const std::string&);
    virtual void netIPSetDefaultGW(const std::string&);
    virtual void netIPSetUseDHCP();

    virtual bool providesDHCPService() const;

  private:
    class cG5EthernetCtrlImpl;
    std::auto_ptr<cG5EthernetCtrlImpl> mpImpl;
  };

#endif // __cG5EthernetCtrl_h
