/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cG5PDIOCtrl_h
  #define __cG5PDIOCtrl_h

#include <memory>
#include <cG5FPGACtrl.h>
#include <cG5AbstractCPDCtrl.h>
#include <cG5ProductInfo.h>

/**
  \brief This class represents one pindriver "slot" in the galep5x.
*/
class cG5PDIOCtrl
  {
  public:
    /// \brief This creates all required objects and throws exceptions of type std::string on fatal errors.
    cG5PDIOCtrl(unsigned int iSlot, cG5ProductInfo::ProductType, unsigned int iFPGABaseMapping);
    ~cG5PDIOCtrl() throw();

    cG5FPGACtrl& fpgaCtrl();
    cG5AbstractCPDCtrl& cpdCtrl();

  private:
    cG5FPGACtrl mFPGACtrl;
    std::auto_ptr<cG5AbstractCPDCtrl> mpCPDCtrl;
  };

#endif // __cG5PDIOCtrl_h
