/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "cAT91RM9200DIO.h"
#include "AT91RM9200.h"
#include "AT91RM9200_SYS.h"

// SNIPPED FROM kernel/include/asm/arch-at91rm9200/hardware.h //
// [

#define AT91C_BASE_SYS		(0xFFFFF000) // (SYS) Base Address
#define AT91C_BASE_PDC_SPI	(0xFFFE0100) // (PDC_SPI) Base Address
#define AT91C_BASE_SPI		(0xFFFE0000) // (SPI) Base Address
#define AT91C_BASE_PDC_SSC2	(0xFFFD8100) // (PDC_SSC2) Base Address
#define AT91C_BASE_SSC2		(0xFFFD8000) // (SSC2) Base Address
#define AT91C_BASE_PDC_SSC1	(0xFFFD4100) // (PDC_SSC1) Base Address
#define AT91C_BASE_SSC1		(0xFFFD4000) // (SSC1) Base Address
#define AT91C_BASE_PDC_SSC0	(0xFFFD0100) // (PDC_SSC0) Base Address
#define AT91C_BASE_SSC0		(0xFFFD0000) // (SSC0) Base Address
#define AT91C_BASE_PDC_US3	(0xFFFCC100) // (PDC_US3) Base Address
#define AT91C_BASE_US3		(0xFFFCC000) // (US3) Base Address
#define AT91C_BASE_PDC_US2	(0xFFFC8100) // (PDC_US2) Base Address
#define AT91C_BASE_US2		(0xFFFC8000) // (US2) Base Address
#define AT91C_BASE_PDC_US1	(0xFFFC4100) // (PDC_US1) Base Address
#define AT91C_BASE_US1		(0xFFFC4000) // (US1) Base Address
#define AT91C_BASE_PDC_US0	(0xFFFC0100) // (PDC_US0) Base Address
#define AT91C_BASE_US0		(0xFFFC0000) // (US0) Base Address
#define AT91C_BASE_EMAC		(0xFFFBC000) // (EMAC) Base Address
#define AT91C_BASE_PDC_MCI	(0xFFFB4100) // (PDC_MCI) Base Address
#define AT91C_BASE_TWI		(0xFFFB8000) // (TWI) Base Address
#define AT91C_BASE_MCI		(0xFFFB4000) // (MCI) Base Address
#define AT91C_BASE_UDP		(0xFFFB0000) // (UDP) Base Address
#define AT91C_BASE_TC5		(0xFFFA4080) // (TC5) Base Address
#define AT91C_BASE_TC4		(0xFFFA4040) // (TC4) Base Address
#define AT91C_BASE_TC3		(0xFFFA4000) // (TC3) Base Address
#define AT91C_BASE_TCB1		(0xFFFA4000) // (TCB1) Base Address
#define AT91C_BASE_TC2		(0xFFFA0080) // (TC2) Base Address
#define AT91C_BASE_TC1		(0xFFFA0040) // (TC1) Base Address
#define AT91C_BASE_TC0		(0xFFFA0000) // (TC0) Base Address
#define AT91C_BASE_TCB0		(0xFFFA0000) // (TCB0) Base Address





#define AT91C_IO_PHYS_BASE	0xFFFA0000
#define AT91C_IO_SIZE		(0xFFFFFFFF - AT91C_IO_PHYS_BASE + 1)
#define AT91C_IO_VIRT_BASE	(0xFF000000 - AT91C_IO_SIZE)

 /* Convert a physical IO address to virtual IO address */
#define AT91_IO_P2V(x)	((x) - AT91C_IO_PHYS_BASE + AT91C_IO_VIRT_BASE)

/*
 * Virtual to Physical Address mapping for IO devices.
 */
#define AT91C_VA_BASE_SYS	AT91_IO_P2V(AT91C_BASE_SYS)
#define AT91C_VA_BASE_SPI	AT91_IO_P2V(AT91C_BASE_SPI)
#define AT91C_VA_BASE_SSC2	AT91_IO_P2V(AT91C_BASE_SSC2)
#define AT91C_VA_BASE_SSC1	AT91_IO_P2V(AT91C_BASE_SSC1)
#define AT91C_VA_BASE_SSC0	AT91_IO_P2V(AT91C_BASE_SSC0)
#define AT91C_VA_BASE_US3	AT91_IO_P2V(AT91C_BASE_US3)
#define AT91C_VA_BASE_US2	AT91_IO_P2V(AT91C_BASE_US2)
#define AT91C_VA_BASE_US1	AT91_IO_P2V(AT91C_BASE_US1)
#define AT91C_VA_BASE_US0	AT91_IO_P2V(AT91C_BASE_US0)
#define AT91C_VA_BASE_EMAC	AT91_IO_P2V(AT91C_BASE_EMAC)
#define AT91C_VA_BASE_TWI	AT91_IO_P2V(AT91C_BASE_TWI)
#define AT91C_VA_BASE_MCI	AT91_IO_P2V(AT91C_BASE_MCI)
#define AT91C_VA_BASE_UDP	AT91_IO_P2V(AT91C_BASE_UDP)
#define AT91C_VA_BASE_TCB1	AT91_IO_P2V(AT91C_BASE_TCB1)
#define AT91C_VA_BASE_TCB0	AT91_IO_P2V(AT91C_BASE_TCB0)
// ]


void cAT91RM9200DIO::cAIC::disableAll()
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    pSys->AIC_IDCR = 0xffffffff;
    pSys->AIC_ICCR = 0xffffffff;
  }


void cAT91RM9200DIO::cAIC::enable(unsigned int i)
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    pSys->AIC_IECR = i;
//  pSys->AIC_ICCR = 0xffffffff;
  }

unsigned int cAT91RM9200DIO::cAIC::getEnabled()
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    return (pSys->AIC_IMR);
  }

void cAT91RM9200DIO::cSystemTimer::enableIRQ()
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    pSys->ST_IER = 0x1;
  }

void cAT91RM9200DIO::cSystemTimer::disableIRQ()
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    pSys->ST_IDR = 0x1;
  }




void cAT91RM9200DIO::cEthernetMAC::enableClock()
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    pSys->PMC_PCER = 1 << AT91C_ID_EMAC;
  }

void cAT91RM9200DIO::cEthernetMAC::disableClock()
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    pSys->PMC_PCDR = 1 << AT91C_ID_EMAC;
  }

void cAT91RM9200DIO::cEthernetMAC::enableIRQ()
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    pSys->PIOC_IER = 4;
  }

void cAT91RM9200DIO::cEthernetMAC::disableIRQ()
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    pSys->PIOC_IDR = 4;
  }


void cAT91RM9200DIO::cGPIO::setPIODirection(cAT91RM9200DIO::cGPIO::Group iPIOGroup, unsigned int iPIOBit, cAT91RM9200DIO::cGPIO::PIODirection iDir)
  {
    setOutput(iPIOGroup, iPIOBit);

    iPIOBit = 1 << iPIOBit;
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    switch (iPIOGroup)
      {
        case PIOA:
          (iDir == fcIn) ? (pSys->PIOA_ODR = (iPIOBit)) : (pSys->PIOA_OER = (iPIOBit));
          pSys->PIOA_PER = iPIOBit;
         break;
        case PIOB:
          (iDir == fcIn) ? (pSys->PIOB_ODR = (iPIOBit)) : (pSys->PIOB_OER = (iPIOBit));
          pSys->PIOB_PER = iPIOBit;
         break;
        case PIOC:
          (iDir == fcIn) ? (pSys->PIOC_ODR = (iPIOBit)) : (pSys->PIOC_OER = (iPIOBit));
          pSys->PIOC_PER = iPIOBit;
         break;
        case PIOD:
          (iDir == fcIn) ? (pSys->PIOD_ODR = (iPIOBit)) : (pSys->PIOD_OER = (iPIOBit));
          pSys->PIOD_PER = iPIOBit;
         break;
      }
  }

void cAT91RM9200DIO::cGPIO::setOutput(cAT91RM9200DIO::cGPIO::Group iPIOGroup, unsigned int iPIOBit, bool boSet)
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    iPIOBit = 1 << iPIOBit;
    switch (iPIOGroup)
      {
      case PIOA:
        (boSet) ? (pSys->PIOA_SODR = iPIOBit) : (pSys->PIOA_CODR = iPIOBit);
       break;
      case PIOB:
        (boSet) ? (pSys->PIOB_SODR = iPIOBit) : (pSys->PIOB_CODR = iPIOBit);
       break;
      case PIOC:
        (boSet) ? (pSys->PIOC_SODR = iPIOBit) : (pSys->PIOC_CODR = iPIOBit);
       break;
      case PIOD:
        (boSet) ? (pSys->PIOD_SODR = iPIOBit) : (pSys->PIOD_CODR = iPIOBit);
       break;
      default:
        ;;
      }
  }


bool cAT91RM9200DIO::cGPIO::getInput(Group iPIOGroup, unsigned int iPIOBit)
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    iPIOBit = 1 << iPIOBit;
    switch (iPIOGroup)
      {
      case PIOA:
        return (pSys->PIOA_PDSR & (iPIOBit));
       break;
      case PIOB:
        return (pSys->PIOB_PDSR & (iPIOBit));
       break;
      case PIOC:
        return (pSys->PIOC_PDSR & (iPIOBit));
       break;
      case PIOD:
        return (pSys->PIOD_PDSR & (iPIOBit));
       break;
      default:
        ;;
      }
    return 0;
  }

#define __raw_readl(x) mcu_read32(x)
#define __raw_writel(x, y) mcu_write32(x, y)

#define __iomem volatile
/**
   \brief Reads a timer / counter register.
   \param iReg - register (offset)
   \param iBlock - 0 for block0 / 1 for block 1
*/
static inline unsigned long at91_tc1_read(unsigned int iReg, unsigned int iBlock)
  {
    unsigned int pBase = (unsigned int)AT91C_VA_BASE_TCB0;
    if (iBlock)
      pBase = (unsigned int)AT91C_VA_BASE_TCB1;
    return (__raw_readl(pBase+iReg));
  }

/**
   \brief Writes a timer / counter register.
   \param iReg - register (offset)
   \param iValue - value to write
   \param iBlock - 0 for block0 / 1 for block 1
*/

static inline void at91_tc1_write(unsigned int iBlock, unsigned int iReg, unsigned long iValue)
  {
    unsigned int pBase = (unsigned int)AT91C_VA_BASE_TCB0;
    if (iBlock)
      pBase = (unsigned int)AT91C_VA_BASE_TCB1;
    __raw_writel(pBase+iReg, iValue);
  }



#include "at91_tc.h"


unsigned int div2(unsigned int iDiv, unsigned int iVol)
  {
//    unsigned int iDiv2 = (iDiv-((iDiv * iVol) / (100)));
//    piDBG("Div1: " << iDiv);
//    piDBG("Div2: " << iDiv2);
    return iDiv-iVol;
  }


#include <iostream>
void cAT91RM9200DIO::cPiezo::set(unsigned int iFreq, unsigned int iVol)
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_VA_BASE_SYS;
    bool boEnable = ((iVol != 0) && (iFreq != 0));
    bool boWasEnable = (pSys->PMC_PCSR & (1 << AT91C_ID_TC3));
//    std::cerr << "Was: " << boWasEnable << std::endl;
    if (boEnable)
      {
        unsigned int iDiv1 = (60000000 / 4) / iFreq;
        unsigned int iDiv2 = div2(iDiv1, iVol);

        unsigned int A = 0;
        if (!(boWasEnable))
          {
            pSys->PMC_PCER = (1 << AT91C_ID_TC3) | (1 << AT91C_ID_TC4);

            at91_tc1_write(1, AT91_TC_CMR+(A),        AT91_TC_WAVESEL | AT91_TC_ASWTRG_CLEAR | AT91_TC_WAVE  | AT91_TC_ACPA_SET | AT91_TC_TIMER_CLOCK1 | AT91_TC_ACPC_CLEAR | AT91_TC_WAVESEL_UPDOWN);
            at91_tc1_write(1, AT91_TC_CMR+(0x40),     AT91_TC_WAVESEL | AT91_TC_ASWTRG_SET | AT91_TC_WAVE  | AT91_TC_ACPA_CLEAR | AT91_TC_TIMER_CLOCK1 | AT91_TC_ACPC_SET | AT91_TC_WAVESEL_UPDOWN);
          }

        at91_tc1_write(1, AT91_TC_RA+(A), iDiv2);
        at91_tc1_write(1, AT91_TC_RC+(A), iDiv1);
        
        at91_tc1_write(1, AT91_TC_RA+(0x40), iDiv2);
        at91_tc1_write(1, AT91_TC_RC+(0x40), iDiv1);
        
        if (!(boWasEnable))
          {
            at91_tc1_write(1, AT91_TC_CCR+(A), AT91_TC_CLKEN);
            at91_tc1_write(1, AT91_TC_CCR+(A), AT91_TC_SWTRG);
            
            at91_tc1_write(1, AT91_TC_CCR+(0x40), AT91_TC_CLKEN);
            at91_tc1_write(1, AT91_TC_CCR+(0x40), AT91_TC_SWTRG);

            // Turn on peripheral pins...
            pSys->PIOB_BSR = (1 << 6); // PIEZZO (1 / TIOA3)
            pSys->PIOB_PDR = (1 << 6);
            pSys->PIOB_OER = (1 << 6);
            
            pSys->PIOB_BSR = (1 << 8); // PIEZZO (1 / TIOA4)
            pSys->PIOB_PDR = (1 << 8);
            pSys->PIOB_OER = (1 << 8);
          }
      }
    else
      {
        pSys->PMC_PCDR = (1 << AT91C_ID_TC3) | (1 << AT91C_ID_TC4);
        
        pSys->PIOB_PER = (1 << 6);
        pSys->PIOB_OER = (1 << 6);
        pSys->PIOB_CODR = (1 << 6);

        pSys->PIOB_PER = (1 << 8);
        pSys->PIOB_OER = (1 << 8);
        pSys->PIOB_CODR = (1 << 8);
      }
  }

