/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cAT91RM9200DIO_h
  #define __cAT91RM9200DIO_h

extern "C" int mcu_read32(unsigned int iAddr);
extern "C" void mcu_write32(unsigned int iAddr, int iData);

/**
  This class provides an interface for low level hardware
  access bypassing the linux kernel.
  All members my be used without object.
*/
class cAT91RM9200DIO
  {
  public:
    // aic //
    class cAIC
      {
      public:
        static void disableAll();
        static void enable(unsigned int iMask = 0xffffffff);
        static unsigned int getEnabled();
      };
    // system timer operations //
    class cSystemTimer
      {
      public:
        static void enableIRQ();
        static void disableIRQ();
      };

    // ethernet mac access //
    class cEthernetMAC
      {
      public:
        static void enableClock();
        static void disableClock();
        static void enableIRQ();
        static void disableIRQ();
      };

    class cGPIO
      {
      public:
        enum Group { PIOA, PIOB, PIOC, PIOD };
        enum PIODirection { fcIn, fcOut };
        static void setPIODirection(Group, unsigned int iPIOBit, PIODirection);
        static void setOutput(Group, unsigned int iPIOBit, bool boSet = true);
        static bool getInput(Group, unsigned int iPIOBit);
        // .. may be continued .. //
      };

    class cPiezo
      {
      public:
        /**
          \brief This function controls PIOB6 and PIOB8.

          You can specify a frequency and a volume (0..100%).
        */
        static void set(unsigned int iFreq, unsigned int iVol);
      };
  };


#endif // __cAT91RM9200DIO_h
