/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "cG5AbstractButtonCtrl.h"


cG5AbstractButtonCtrl::cG5AbstractButtonCtrl()
  : mboFirst(true), miSP(0), miLP(0), miVP(0),
    mboPostedPS(false), mboPostedPL(false), mboPostedPVL(false)
      { }

cG5AbstractButtonCtrl::~cG5AbstractButtonCtrl() throw()
  { }

cG5AbstractButtonCtrl::Event cG5AbstractButtonCtrl::event()
  {
    if (mboFirst)
      {
        mboFirst = false;
        update();
        miSP = shortPress();
        miLP = longPress();
        miVP = veryLongPress();
        return evNone;
      }

    update();
    Event ev = evNone;
    bool boIsDown = isDown();
    
    if (veryLongPress() > miVP)
      {
        if (!(boIsDown))
          ev = evVeryLong;
        else
          {
            if (!(mboPostedPVL))
              ev = evPendingVeryLong;
            mboPostedPVL = true;
          }
      }
    else
      if (longPress() > miLP)
        {
          if (!(boIsDown))
            ev = evLong;
          else
            {
              if (!(mboPostedPL))
                ev = evPendingLong;
              mboPostedPL = true;
            }
        }
      else
        if (shortPress() > miSP)
          {
            if (!(boIsDown))
              ev = evShort;
            else
              {
                if (!(mboPostedPS))
                  ev = evPendingShort;
                mboPostedPS = true;
              }
          }


    if (!(boIsDown))
      {
        miSP = shortPress();
        miLP = longPress();
        miVP = veryLongPress();
        mboPostedPS = false;
        mboPostedPL = false;
        mboPostedPVL = false;
      }
    return ev;
  }

