/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cCPDCtrlReg_h
  #define __cCPDCtrlReg_h

#define DAT_NULL_MODE               0x0
//CFG0-1 PULL-DOWN
#define DAT_PULL_DOWN_NONE          0x0
#define DAT_PULL_DOWN_01            0x1 //0,1 mA
#define DAT_PULL_DOWN_05            0x2 //0,5 mA
#define DAT_PULL_DOWN_5             0x3 //5   mA

//CFG2-3 PULL-UP
#define DAT_PULL_UP_NONE            0x0
#define DAT_PULL_UP_01              0x4 //0,1 mA
#define DAT_PULL_UP_05              0x8 //0,5 mA
#define DAT_PULL_UP_5               0xC //5   mA

//CFG4-5 Power-Switch select
#define DAT_PWR_GND_SELECT          0x00
#define DAT_PWR_VCP1_SELECT         0x10
#define DAT_PWR_VCP2_SELECT         0x20
#define DAT_PWR_VCP3_SELECT         0x30

//CFG6-8 Power Modes
#define DAT_PWR_MODE_NONE           0x00
#define DAT_PWR_ONLY_MODE           0x40
#define DAT_PWR_DX_MODE             0x80
#define DAT_PWR_OE_MODE             0xC0

//CFG9-11 Logic Modes
#define DAT_LOGIC_MODE_NONE         0x000
#define DAT_LOGIC_BIDIR_MODE_1K     0x200
#define DAT_LOGIC_BIDIR_MODE_30     0x400
#define DAT_LOGIC_BIDIR_MODE_25     0x600
#define DAT_LOGIC_LS_MODE           0xA00
#define DAT_LOGIC_COMP_MODE         0xC00
#define DAT_LOGIC_DIR_MODE          0xE00
                
#endif // ____cCPDCtrlReg_h
