/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "cG5PDIOCtrl.h"
#include "devices/cG5MCPDCtrl.h"
#include "devices/cG5DCPDCtrl.h"
#include "devices/cG5PCPDCtrl.h"


cG5PDIOCtrl::cG5PDIOCtrl(unsigned int iSlot, cG5ProductInfo::ProductType product, unsigned int iFPGABaseMapping)
  : mFPGACtrl(iSlot, iFPGABaseMapping), mpCPDCtrl(0)
    {
      switch (product)
        {
          case cG5ProductInfo::Galep5M:
            mpCPDCtrl.reset(new cG5MCPDCtrl(mFPGACtrl));
           break;
          case cG5ProductInfo::Galep5Pro:
            mpCPDCtrl.reset(new cG5DCPDCtrl(mFPGACtrl));
           break;
          case cG5ProductInfo::Galep5P:
            mpCPDCtrl.reset(new cG5PCPDCtrl(mFPGACtrl));
           break;
          case cG5ProductInfo::Unknown:
           break;
        }
      if (!(mpCPDCtrl.get()))
        throw std::string("cG5PDIOCtrl: Unknown product");
    }

cG5PDIOCtrl::~cG5PDIOCtrl() throw()
  {
  }

cG5FPGACtrl& cG5PDIOCtrl::fpgaCtrl()
  { return mFPGACtrl; }

cG5AbstractCPDCtrl& cG5PDIOCtrl::cpdCtrl()
  { return *mpCPDCtrl; }

