/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "cG5DCPDCtrl.h"


// see opc-zuordnung-g5d-pd1.txt //
static const unsigned char gOPCIdxPD1[] = { 20, 21, 22, 23, 24, 25, 26, 27, 28, 29,
                                            10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
                                            0,  2,  4,  6,  9,  8,  7,  5,  3,  1,
                                            59, 57, 55, 53, 50, 51, 52, 54, 56, 58,
                                            40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
                                            30, 31, 32, 33, 34, 35, 36, 37, 38, 39};

static const unsigned char gOPCIdxPD2[] = { 49, 48, 47, 46, 45, 44, 43, 42, 41, 40,
                                            59, 57, 55, 53, 50, 51, 52, 54, 56, 58,
                                            0,  2,  4,  6,  9,  8,  7,  5,  3,  1,
                                            19, 18, 17, 16, 15, 14, 13, 12, 11, 10,
                                            29, 28, 27, 26, 25, 24, 23, 22, 21, 20,
                                            39, 38, 37, 36, 35, 34, 33, 32, 31, 30 };

static const unsigned char gOPCIdxPD3[] = { 49, 48, 47, 46, 45, 44, 43, 42, 41, 40,
                                            58, 56, 54, 52, 51, 50, 53, 55, 57, 59,
                                            1,  3,  5,  7,  8,  9,  6,  4,  2,  0,
                                            19, 18, 17, 16, 15, 14, 13, 12, 11, 10,
                                            29, 28, 27, 26, 25, 24, 23, 22, 21, 20,
                                            39, 38, 37, 36, 35, 34, 33, 32, 31, 30 };

static const unsigned char gOPCIdxPD4[] = { 20, 21, 22, 23, 24, 25, 26, 27, 28, 29,
                                            10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
                                            1,  3,  5,  7,  8,  9,  6,  4,  2,  0,
                                            58, 56, 54, 52, 51, 50, 53, 55, 57, 59,
                                            40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
                                            30, 31, 32, 33, 34, 35, 36, 37, 38, 39 };

static const unsigned char* gG5DOPCMappingTable[4] = { gOPCIdxPD1, gOPCIdxPD2, gOPCIdxPD3, gOPCIdxPD4 };





cG5DCPDCtrl::cG5DCPDCtrl(cG5FPGACtrl& fpgaCtrl)
  : cG5AbstractCPDCtrl(fpgaCtrl)
    { }

cG5DCPDCtrl::~cG5DCPDCtrl() throw()
  { }

unsigned int cG5DCPDCtrl::numCPDs() const
  { return 6; } // we have 6 cpds per "slot" //

unsigned int cG5DCPDCtrl::numUsedPinDrivers() const
  { return 60; } // we use all pindrivers //

const unsigned char* cG5DCPDCtrl::mappingVector(unsigned int i) const
  {
    if (i >= 4)
      throw std::string("cG5DCPDCtrl: invalid slot index!");
    return gG5DOPCMappingTable[i];
  }
