/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "cG5PCPDCtrl.h"


static const unsigned char gOPCIdxPD[] = { 50, 51, 52, 53, 54, 55, 56, 57, 58, 59,
                                           40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
                                           30, 31, 32, 33, 34, 35, 36, 37, 38, 39,
                                           20, 21, 22, 23, 24, 25, 26, 27, 28, 29,
                                           10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
                                            9,  8,  7,  6,  5,  4,  3,  2,  1, 0 };

cG5PCPDCtrl::cG5PCPDCtrl(cG5FPGACtrl& fpgaCtrl)
  : cG5AbstractCPDCtrl(fpgaCtrl)
    { }

cG5PCPDCtrl::~cG5PCPDCtrl() throw()
  { }

unsigned int cG5PCPDCtrl::numCPDs() const
  { return 6; } // we have 6 cpds per "slot" //

unsigned int cG5PCPDCtrl::numUsedPinDrivers() const
  { return 60; } // we use all pindrivers //

const unsigned char* cG5PCPDCtrl::mappingVector(unsigned int i) const
  {
    return gOPCIdxPD;
  }
