/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include <string>
#include "cG5AbstractPSCtrl.h"
#include "cG5PSCtrl.h"
#include "g5ps-rev1/cG5PSCtrlR1Impl.h"


cG5PSCtrl::cG5PSCtrl(cG5PDIOCtrl*, cG5ProductInfo::ProductType iProduct)
  : mpImpl()
  {
    // We support revision 1 by default. //
    mpImpl = std::auto_ptr<cG5AbstractPSCtrl>(new cG5PSCtrlR1Impl(iProduct));
  }

cG5PSCtrl::~cG5PSCtrl() throw()
  {
    // auto_ptr should release mpImpl //
  }

cG5AbstractPSCtrl& cG5PSCtrl::psCtrl()
  {
    if (!(mpImpl.get()))
      throw std::string("cG5PSCtrl: no implementation");
    return *mpImpl.get();
  }
