/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cG5PSCtrlR1Impl_h
  #define __cG5PSCtrlR1Impl_h

#include <cG5ProductInfo.h>
#include "cG5PSCtrlR1.h"
#include "../cG5AbstractPSCtrl.h"

/**
  \brief Implementation to control the galep5 power supplies.
  (rev-1: 1x AtMega48 / 88)
*/
class cG5PSCtrlR1Impl : public cG5AbstractPSCtrl
  {
  public:
    cG5PSCtrlR1Impl(cG5ProductInfo::ProductType);
    virtual ~cG5PSCtrlR1Impl() throw();

    virtual bool resetPowerSupplies();
    virtual unsigned int dacBits() const;

    virtual bool setVoltage(Supply, unsigned int imV);

    virtual bool setVoltageDAC(Supply, unsigned int iDAC);
    virtual unsigned int getVoltageADC(Supply, bool& boOk);

    virtual void setSupplyCalibData(Supply, double dGradient, double dOffset);
    virtual void storeCalibration();

    virtual std::string getFwVersion() const;
    virtual bool getCurrentDraws(unsigned int& iIGate, unsigned int& iIComp, unsigned int& iILS, unsigned int& iICP1, unsigned int& iICP2, unsigned int& iICP3);
    virtual bool getVoltages(unsigned int& iVGate, unsigned int& iVComp, unsigned int& iVLS, unsigned int& iVCP1, unsigned int& iVCP2, unsigned int& iVCP3, unsigned int& iUIn);
    virtual bool isVoltageReadable(Supply);
    virtual bool isCurrentDrawReadable(Supply);

    virtual bool hasDischarge(Supply) const;
    virtual void setDischarge(Supply, bool);

    virtual void setupMCU(const char* pBf, unsigned int iSize);

  private:
    cG5PSCtrlR1 mPSCtrl;
    cG5ProductInfo::ProductType miProductType;
  };

#endif // __cG5PSCtrlR1Impl_h
