/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "cSPICtrl.h"

cSPICtrl::cSPICtrl()
  : mAttrRAWSPI(ATTR_SPI_RAW), mAttrSPI(ATTR_SPI), mAttrSPICS(ATTR_SPI_CS), mAttrSPIRST(ATTR_SPI_RESET)
  {
  }

cSPICtrl::~cSPICtrl() throw()
  { }

/**
  If boCtrlSelect is true the chip select line will be controlled by
  the device-driver.
  On boCtrlSelect = false the device driver will never touch the
  chip select signal. You may control it via setSelect().
*/
char cSPICtrl::spiIO(char bIn, bool boCtrlSelect)
  {
    cDriverAttribute& attr = (boCtrlSelect) ? (mAttrSPI) : (mAttrRAWSPI);
    attr.write8(bIn);
    char bReturn = 0;
    bReturn = mAttrSPI.read8();
    return (bReturn);
  }

void cSPICtrl::setSelect(bool bo)
  {
    mAttrSPICS.write8((bo) ? (1):(0));
  }

void cSPICtrl::setReset(bool bo)
  {
    mAttrSPIRST.write8((bo) ? (1):(0));
  }
