/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "cG5EthernetCtrl.h"
#include "cG5FirmwareCtrl.h"
#include <cTinyFsFileAttribute.h>

class cG5EthernetCtrl::cG5EthernetCtrlImpl
  {
  public:
    cG5EthernetCtrlImpl::cG5EthernetCtrlImpl()
      {
      }
    cG5EthernetCtrlImpl::~cG5EthernetCtrlImpl() throw()
      { }

  public:
    cG5FirmwareCtrl mFirmwareCtrl;
  };


cG5EthernetCtrl::cG5EthernetCtrl()
  {
    mpImpl.reset(new cG5EthernetCtrlImpl());
  }

cG5EthernetCtrl::~cG5EthernetCtrl() throw()
  { /* auto_ptr destroys implementation */ }

std::string cG5EthernetCtrl::macAddress()
  { return cTinyFsFileAttribute::getStringAttr("mac-address"); }

std::string cG5EthernetCtrl::netIPAddress()
  {
    try { return cTinyFsFileAttribute::getStringAttr("eth0-address"); }
    catch (...)
      { return ("unknown"); }
   }

std::string cG5EthernetCtrl::netIPDefaultGW()
  {
    try { return cTinyFsFileAttribute::getStringAttr("eth0-gateway"); }
    catch (...)
      { return ("unknown"); }
  }

bool cG5EthernetCtrl::netIPUseDHCP()
  {
    try {
      std::string s = cTinyFsFileAttribute::getStringAttr("eth0-address");
      return (s == "dhcp");
    }
    catch (...)
      { return (false); }
  }

void cG5EthernetCtrl::netIPSetAddress(const std::string& s)
  { cTinyFsFileAttribute::setStringAttr("eth0-address", s); }

void cG5EthernetCtrl::netIPSetDefaultGW(const std::string& s)
  { cTinyFsFileAttribute::setStringAttr("eth0-gateway", s); }

void cG5EthernetCtrl::netIPSetUseDHCP()
  { cTinyFsFileAttribute::setStringAttr("eth0-address", "dhcp"); }

bool cG5EthernetCtrl::providesDHCPService() const
  { return false; }
