/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "cG5USBNetCtrl.h"
#include "cG5FirmwareCtrl.h"
#include <cTinyFsFileAttribute.h>

class cG5USBNetCtrl::cG5USBNetCtrlImpl
  {
  public:
    cG5USBNetCtrlImpl::cG5USBNetCtrlImpl()
      {
      }
    cG5USBNetCtrlImpl::~cG5USBNetCtrlImpl() throw()
      { }

  public:
    cG5FirmwareCtrl mFirmwareCtrl;
  };


cG5USBNetCtrl::cG5USBNetCtrl()
  {
    mpImpl.reset(new cG5USBNetCtrlImpl());
  }

cG5USBNetCtrl::~cG5USBNetCtrl() throw()
  { /* auto_ptr destroys implementation */ }

bool cG5USBNetCtrl::isInstalled()
  {
    return false;
  }


std::string cG5USBNetCtrl::macAddress()
  { return "?"; }

std::string cG5USBNetCtrl::netIPAddress()
  {
    try { return cTinyFsFileAttribute::getStringAttr("usb0-address"); }
    catch (...)
      { return ("unknown"); }
   }

std::string cG5USBNetCtrl::netIPDefaultGW()
  {
    try { return cTinyFsFileAttribute::getStringAttr("usb0-gateway"); }
    catch (...)
      { return ("unknown"); }
  }

bool cG5USBNetCtrl::netIPUseDHCP()
  {
    try {
      std::string s = cTinyFsFileAttribute::getStringAttr("usb0-address");
      return (s == "dhcp");
    }
    catch (...)
      { return (false); }
  }

void cG5USBNetCtrl::netIPSetAddress(const std::string& s)
  { cTinyFsFileAttribute::setStringAttr("usb0-address", s); }

void cG5USBNetCtrl::netIPSetDefaultGW(const std::string& s)
  { cTinyFsFileAttribute::setStringAttr("usb0-gateway", s); }

void cG5USBNetCtrl::netIPSetUseDHCP()
  { cTinyFsFileAttribute::setStringAttr("eth0-address", "dhcp"); }

bool cG5USBNetCtrl::providesDHCPService() const
  { return false; }
