/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cGuardedBuffer_h
  #define __cGuardedBuffer_h

class cGuardedBuffer
  {
  public:
    cGuardedBuffer(unsigned int i)
      : mpBuffer(new char[i]), miSize(i)
      { }

    ~cGuardedBuffer()
      { delete[] mpBuffer; }

    char* data() const
      { return mpBuffer; }

    unsigned int size() const
      { return miSize; }

    void fillZero()
      { fill(0); }

    void fill(char b)
      { memset(mpBuffer, b, miSize); }

  private:
    char* mpBuffer;
    unsigned int miSize;
  };

#endif // __cGuardedBuffer_h
