/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cTinyFsFileAttribute_h
  #define __cTinyFsFileAttribute_h

#include <string>
#include <cGuardedBuffer.h>

/**
  \brief Provides convenient access to tinyfs files.
*/
class cTinyFsFileAttribute
  {
  public:
    static bool tryGetStringAttr(std::string& sReturn, const std::string& sFile, const std::string& sDevice = "/dev/mtd0");
    static std::string getStringAttr(const std::string& sFile, const std::string& sDevice = "/dev/mtd0");
    static void setStringAttr(const std::string& sFile, const std::string& s, const std::string& sDevice = "/dev/mtd0");

    static std::auto_ptr<cGuardedBuffer> getFileContent(const std::string& sFile, const std::string& sDevice = "/dev/mtd0");
    static void setFileContent(const std::string& sFile, const cGuardedBuffer&, const std::string& sDevice = "/dev/mtd0");
  };



#endif // __cTinyFsFileAttribute_h
